> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/signing/transactionsigner.md).

# TransactionSigner

A class for signing Stacks transactions. Manages the signing process for both single-sig and multi-sig transactions, as well as sponsored transactions.

***

### Usage

```ts
import {
  makeUnsignedSTXTokenTransfer,
  TransactionSigner,
} from '@stacks/transactions';

// Create an unsigned transaction
const transaction = await makeUnsignedSTXTokenTransfer({
  recipient: 'ST1SJ3DTE5DN7X54YDH5D64R3BCB6A2AG2ZQ8YPD5',
  amount: 1000000n,
  publicKey: '034f355bdcb7cc0af728ef3cceb9615d90684bb5b2ca5f859ab0f0b704075871aa',
  network: 'testnet',
  fee: 200n,
  nonce: 0n,
});

// Sign with the origin's private key
const signer = new TransactionSigner(transaction);
signer.signOrigin('b244296d5907de9864c0b0d51f98a13c52890be0404e83f273144004b81874603');

// For sponsored transactions
const sponsorSigner = TransactionSigner.createSponsorSigner(
  transaction,
  sponsorSpendingCondition
);
sponsorSigner.signSponsor(sponsorPrivateKey);
```

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/signer.ts)

***

### Definition

```ts
class TransactionSigner {
  transaction: StacksTransactionWire;
  sigHash: string;
  originDone: boolean;
  checkOversign: boolean;
  checkOverlap: boolean;

  constructor(transaction: StacksTransactionWire);
}
```

***

### Static Methods

#### TransactionSigner.createSponsorSigner

Creates a signer for the sponsor of a sponsored transaction.

```ts
static createSponsorSigner(
  transaction: StacksTransactionWire,
  spendingCondition: SpendingConditionOpts
): TransactionSigner;
```

***

### Instance Methods

#### signOrigin

Signs the transaction as the origin (sender). For multi-sig, call this multiple times with each signer's key.

```ts
signOrigin(privateKey: PrivateKey): void;
```

#### appendOrigin

Appends a public key to the origin authorization for multi-sig transactions (for signers that did not sign).

```ts
appendOrigin(publicKey: PublicKey): void;
```

#### signSponsor

Signs the transaction as the sponsor.

```ts
signSponsor(privateKey: PrivateKey): void;
```

#### getTxInComplete

Returns a deep clone of the transaction in its current state.

```ts
getTxInComplete(): StacksTransactionWire;
```

#### resume

Resumes signing from a different transaction state.

```ts
resume(transaction: StacksTransactionWire): void;
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/signing/transactionsigner.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
